
#property copyright " 2008-2012 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define vers   "1.0"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  MediumTurquoise
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_color4  Gold
#property indicator_style1  STYLE_SOLID
#property indicator_style2  STYLE_SOLID
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  1
#property indicator_width4  1


extern int RVI_Period = 12;
extern int Bands_Period = 65;
extern double Bands_Deviation = 1.3;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double RVIBuffer[];
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];

string short_name;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  IndicatorBuffers(4);
    
  SetIndexStyle(0, DRAW_LINE);
  SetIndexStyle(1, DRAW_LINE);
  SetIndexStyle(2, DRAW_LINE);
  SetIndexStyle(3, DRAW_LINE);
  
  SetIndexBuffer(0, RVIBuffer);
  SetIndexBuffer(1, MovingBuffer);
  SetIndexBuffer(2, UpperBuffer);
  SetIndexBuffer(3, LowerBuffer);
    
  SetIndexDrawBegin(0, RVI_Period);
  SetIndexDrawBegin(1, Bands_Period);
  SetIndexDrawBegin(2, Bands_Period);
  SetIndexDrawBegin(3, Bands_Period);

  short_name = "PowerRVI("+RVI_Period+","+Bands_Period+"," + DoubleToStr(Bands_Deviation, 2)+")";
  IndicatorShortName(short_name);
  
  SetIndexLabel(0, "RVI");
  SetIndexLabel(1, "RVIS");
  SetIndexLabel(2, "U.Bands");
  SetIndexLabel(3, "L.Bands");

  IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 1);
}

void deinit()
{
}

void start() 
{  
  //-----
  
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars <= Bands_Period) return;
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=Bands_Period;i++)
        {
         RVIBuffer[Bars-i]=EMPTY_VALUE;
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   
   for(i=0; i<limit; i++) {
     RVIBuffer[i] = 
      MathMin(Volume[i],RVI_Period+Bands_Period) * 
      iRVI(NULL, 0, RVI_Period, MODE_MAIN, i);
   }
   
   for(i=0; i<limit; i++) {
     //MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_EMA,PRICE_CLOSE,i);
     MovingBuffer[i] = iMAOnArray(RVIBuffer, 0, Bands_Period, 0, MODE_EMA, i);
   }
   
//----
   i=Bars-Bands_Period+1;
   if(counted_bars>Bands_Period-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+Bands_Period-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         //newres=Close[k]-oldval;
         newres=RVIBuffer[k]-oldval;
         
         sum+=newres*newres;
         k--;
        }
      deviation=Bands_Deviation*MathSqrt(sum/Bands_Period);
      UpperBuffer[i]=oldval+deviation;
      LowerBuffer[i]=oldval-deviation;
      i--;
    }
}